extends Sprite

const TIME_BLUR := 2.0; # 2秒

# ブラーの有効時間
var time_blur := 0.0

func start_radial_blur(pos:Vector2) -> void:
	# テクスチャのサイズ
	var tex_size := texture.get_size()
	
	# シェーダーに渡すブラーの中心座標
	var blur_center := Vector2()
	blur_center.x = pos.x / tex_size.x
	blur_center.y = pos.y / tex_size.y
	
	# 中心座標を設定
	material.set_shader_param("center", blur_center)
	
	# 放射ブラー開始
	time_blur = TIME_BLUR
	
func _input(event: InputEvent) -> void:
	if event is InputEventMouseButton:
		if event.is_pressed():
			# クリックで放射ブラー開始
			start_radial_blur(get_viewport().get_mouse_position())
	
func _process(delta: float) -> void:
	
	material.set_shader_param("strength", 0)
	if time_blur > 0:
		# シェーダー更新
		time_blur = max(0, time_blur - delta)
		# sinカーブで 0.0〜1.0 の半円を移動する
		var force := abs(sin(PI * time_blur / TIME_BLUR))
		material.set_shader_param("strength", force)
